/*
  * hammurapi-rules-tutorial @mesopotamia.version@
 * Hammurapi rules tutorial. 
 * Copyright (C) 2006  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://http://www.hammurapi.biz
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi.rules.tutorial.conclusions;

import biz.hammurapi.rules.Conclusion;
import biz.hammurapi.rules.tutorial.facts.Person;

public class Relative extends Conclusion implements Comparable {

	public Relative(Person subject, Person object) {
		setSlot("subject", subject);
		setSlot("object", object);
		synchronized (Relative.class) {
			serialNo = ++counter;
		}
	}

	public String toString() {
		StringBuffer ret = new StringBuffer(getSubject().toString());
		ret.append(" is a ");
		
		int idx = getClass().getName().lastIndexOf('.');
		ret.append(idx == -1 ? getClass().getName() : getClass().getName().substring(idx + 1));
		ret.append(" of ");
		ret.append(getObject().toString());
		
		ret.append(" (");
		ret.append(getDepth());
		ret.append("/");
		ret.append(getCardinality());
		ret.append(")");
		return ret.toString();
	}
	
	public Person getSubject() {
		return (Person) getSlot("subject");
	}
	
	public Person getObject() {
		return (Person) getSlot("object");
	}
	
	private static int counter;
	
	private int serialNo;

	public int compareTo(Object o) {
		if (o==null) {
			return -1;
		}
		return o instanceof Relative ? serialNo-((Relative) o).serialNo : hashCode()-o.hashCode();
	}
}
