/*
  * hammurapi-rules-tutorial @mesopotamia.version@
 * Hammurapi rules tutorial. 
 * Copyright (C) 2006  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://http://www.hammurapi.biz
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi.rules.tutorial.facts;

import org.w3c.dom.Element;

import biz.hammurapi.xml.dom.DomSerializable;

public class Person implements DomSerializable {

	private String name;

	private boolean isMale;
	
	private int age;

	public Person(String name, int age, boolean isMale) {
		super();
		this.name = name;
		this.age = age;
		this.isMale = isMale;
	}

	public String toString() {
		return name + " ["+(isMale ? "male " : "female ")+age+"]";
	}

	public boolean equals(Object obj) {
		return obj instanceof Person 
		&& name.equals(((Person) obj).name) 
		&& isMale == ((Person) obj).isMale 
		&& age == ((Person) obj).age;
	}

	public int hashCode() {
		return name.hashCode() 
		^ (isMale ? 0 : 1) 
		^ age;
	}
	
	public boolean isMale() {
		return isMale;
	}
	
	public int getAge() {
		return age;
	}
	
	public String getName() {
		return name;
	}

	public void toDom(Element holder) {
		holder.setAttribute("name", name);
		holder.setAttribute("type", getClass().getName());
		holder.setAttribute("gender", isMale ? "male" : "female");
		holder.setAttribute("age", String.valueOf(age));
	}
}
