/*
 * hammurapi-rules-tutorial @mesopotamia.version@
 * Hammurapi rules tutorial. 
 * Copyright (C) 2006  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://http://www.hammurapi.biz
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi.rules.tutorial.rules;

import biz.hammurapi.rules.Rule;
import biz.hammurapi.rules.tutorial.conclusions.Father;
import biz.hammurapi.rules.tutorial.conclusions.Mother;
import biz.hammurapi.rules.tutorial.conclusions.Parent;

public class ParentRules extends Rule {	
		
	public ParentRules() {
		setMethodFactTypes(Parent.class, new Class[] { Father.class, Mother.class });
	}
	
	/**
	 * Male parent is father, female parent is mother.
	 * @param parent
	 * @return Brother or Sister.
	 */
	public Parent infer(Parent parent) {	
		
		if (parent.getSubject().isMale()) {
			if (!(parent instanceof Father)) {
				return new  Father(parent.getSubject(), parent.getObject());
			}			
		} else {
			if (!(parent instanceof Mother)) {
				return new Mother(parent.getSubject(), parent.getObject());
			}			
		}
		return null;
	}
}
