/*
 * hammurapi-rules-tutorial @mesopotamia.version@
 * Hammurapi rules tutorial. 
 * Copyright (C) 2006  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://http://www.hammurapi.biz
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi.rules.tutorial.rules;

import biz.hammurapi.rules.Rule;
import biz.hammurapi.rules.tutorial.conclusions.Husband;
import biz.hammurapi.rules.tutorial.conclusions.Spouse;
import biz.hammurapi.rules.tutorial.conclusions.Wife;

public class SpouseRules extends Rule {	
		
	public SpouseRules() {
		setMethodFactTypes(Spouse.class , new Class[] {Husband.class, Wife.class});
	}
	
	/**
	 * Male spouse is husband, female spouse is wife.
	 * If A is a spouse of B then B is a spouse of A. 
	 * @param spouse
	 * @return Brother or Sister.
	 */
	public Spouse infer(Spouse spouse) {
		post(new Spouse(spouse.getObject(), spouse.getSubject()));
		
		if (spouse.getSubject().isMale()) {
			if (!(spouse instanceof Husband)) {
				return new  Husband(spouse.getSubject(), spouse.getObject());
			}			
		} else {
			if (!(spouse instanceof Wife)) {
				return new Wife(spouse.getSubject(), spouse.getObject());
			}			
		}
		return null;
	}
}
